package usluga.klient;

import jakarta.xml.ws.BindingProvider;
import jakarta.xml.ws.soap.SOAPFaultException;
import usluga.generated.Osoba;
import usluga.generated.Usluga;
import usluga.generated.UslugaService;

public class Klient2_Walidacja {

    public static void main(String[] args) {
        UslugaService service = new UslugaService();
        Usluga proxy = service.getUslugaPort();
        ((BindingProvider)proxy).getRequestContext().put("schema-validation-enabled", true);

        // To włącza walidację wiadomości wychodzących i (na 90%) przychodzących
        // w razie niespełniania wymagań operacja zarejestruj (lub inna metoda) wyrzuca wyjątek SOAPFaultException
        // z odpowiednimi opisami i "cause"

        Osoba ala = new Osoba();
        ala.setImie("Ala");
        ala.setNazwisko("Dodatnia");
        ala.setNrButa(30);
        System.out.println("Rejestruję 1");
        try {
            proxy.zarejestruj(ala);
            System.out.println("Zarejetrowane 1");
        } catch (SOAPFaultException e) {
            System.out.println("Serwer odrzucił zapytanie. " + e);
        } catch (Exception e) {
            System.out.println("Inny błąd: " + e);
        }

        Osoba ola = new Osoba();
        ola.setImie("Ala");
        ola.setNazwisko("Dodatnia");
        ola.setNrButa(-30);
        System.out.println("Rejestruję 2");
        try {
            proxy.zarejestruj(ola);
            System.out.println("Zarejetrowane 2");
        } catch (SOAPFaultException e) {
            System.out.println("Serwer odrzucił zapytanie. " + e);
            System.out.println(e.getClass());
            System.out.println("przyczyna: " + e.getCause());
        } catch (Exception e) {
            System.out.println("Inny błąd: " + e);
        }

        System.out.println("Gotowe");
    }
}
